//+------------------------------------------------------------------+
//|                                                   HaosVisual.mq4 |
//|                                               original by mrslav |
//|                                           this version by mladen |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 DarkGoldenrod
#property indicator_width1 1
#property indicator_color2 Lime
#property indicator_color3 Coral
#property indicator_width3 2
#property indicator_color4 Coral
#property indicator_width4 2
#property indicator_color5 Lime
#property indicator_width5 2
#property indicator_color6 Lime
#property indicator_width6 2
#property indicator_color7 DodgerBlue
#property indicator_maximum 50
#property indicator_minimum -50

extern string TimeFrame  = "Current time frame";
extern string WPR1        = "*** WPR1 ***";
extern int    t3_period   = 8;
extern double b           = 0.7;
extern int    per         = 14;
extern int    psel        = 30;
extern int    pbuy        = -30;
extern string WPR2        = "*** WPR2 ***";
extern int    t3_period_2 = 8;
extern double b_2         = 0.7;
extern int    per_2       = 96;
extern int    psel_2      = 40;
extern int    pbuy_2      = -40;

double Buffer1[];
double Buffer2[];
double Dn2[];
double Dn1[];
double Mid[];
double Up1[];
double Up2[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init() 
{
   SetIndexBuffer(0,Buffer1); SetIndexLabel(0,"  ");
   SetIndexBuffer(1,Buffer2); SetIndexLabel(1,"  ");
   SetIndexBuffer(2,Up1);     SetIndexLabel(2," ");
   SetIndexBuffer(3,Dn1);     SetIndexLabel(3," ");
   SetIndexBuffer(4,Up2);     SetIndexLabel(4," ");
   SetIndexBuffer(5,Dn2);     SetIndexLabel(5,"  ");
   SetIndexBuffer(6,Mid); 
      SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexStyle(4,DRAW_HISTOGRAM);
      SetIndexStyle(5,DRAW_HISTOGRAM);
      SetIndexStyle(6,DRAW_HISTOGRAM);
      SetLevelValue(0,psel_2);
      SetLevelValue(1,psel);
      SetLevelValue(2,0);
      SetLevelValue(3,pbuy);
      SetLevelValue(4,pbuy_2);

         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);

   IndicatorShortName("Haos Visual");
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buffer1[0] = limit+1; return(0); }
       
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     for (int i=limit; i>=0; i--)
     {
         Buffer1[i] = iT3(iWPR(NULL,0,per,i)  ,t3_period  ,b  ,false,i,0)+50;
         Buffer2[i] = iT3(iWPR(NULL,0,per_2,i),t3_period_2,b_2,false,i,1)+50;
         Up2[i]=EMPTY_VALUE; 
   	   Dn1[i]=EMPTY_VALUE; 
	      Up1[i]=EMPTY_VALUE; 
	      Dn2[i]=EMPTY_VALUE; 
         Mid[i]=EMPTY_VALUE; 


           if (Buffer1[i]> psel && Buffer2[i]>psel_2) Dn2[i]=Buffer2[i];
      else if (Buffer1[i]<=psel && Buffer2[i]>psel_2) Dn1[i]=Buffer2[i];
	   else if (Buffer1[i]< pbuy && Buffer2[i]<pbuy_2) Up2[i]=Buffer2[i];
	   else if (Buffer1[i]>=pbuy && Buffer2[i]<pbuy_2) Up1[i]=Buffer2[i];
      else                                            Mid[i]=Buffer2[i];
      }
      return(0); 
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,0,y);
         Buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,1,y);
         Up1[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,2,y);
         Dn1[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,3,y);
         Up2[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,4,y);
         Dn2[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,5,y);
         Mid[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,6,y);
   }   
   return(0);

}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}